BEGIN {
	scan=1;

	for(i=0;i<162;i++)
		reg[i]=-1
	for(i=0;i<255;i++)
	{
		slope0[i]=-1
		slope1[i]=-1
	}

	# frontend 
	fereg[0]=-1
	fereg[1]=-1
	fereg[2]=-1
	fereg[3]=-1

	sign[0]=-1
	sign[1]=-1
	sign[2]=-1
	sign[3]=-1

	gain[0]=-1
	gain[1]=-1
	gain[2]=-1
	gain[3]=-1

	global_sign=-1
}
function decode(reg,val)
{
	idx=strtonum("0x"reg)
	R[idx]=val;

	if(reg=="01") {
		unipolar[0]="two-phase-on full step"
		unipolar[1]="half step"
		unipolar[2]="reserved"
		unipolar[3]="single-phase-on full step"
		bipolar[0]="full step"
		bipolar[1]="half step"
		bipolar[2]="quarter step"
		bipolar[3]="reserved"
		if(and(val,128))
			printf "CIS, "
		else
			printf "CCD, "
		if(and(val,64))
			printf "watchdog, "
		if(and(val,32))
			printf "enable shading, "
		else
			printf "disable shading, "
		if(and(val,16))
		{
			printf "fast scanning, "
			FASTMODE=1
		}
		else
		{
			printf "normal scanning, "
			FASTMODE=0
		}
		if(and(val,8))
			printf "data compression, "
		else
			printf "uncompressed data, "
		if(and(val,4))
			printf "DRAM 4Mx2, "
		else
			printf "DRAM 4Mx1, "
		if(and(val,2))
			printf "shading area, "
		else
			printf "shading whole line, "
		if(and(val,1))
			printf "enable scan"
		else
			printf "disable scan"
		return;
	}
	if(reg=="02") {
		if(and(val,128))
			printf "auto-go-home disabled, "
		else
			printf "auto-go-home enabled, "
		if(and(val,64))
			printf "disable moving when buffer full, "
		else
			printf "enable moving when buffer full, "
		if(and(val,32))
			printf "auto-go-home after scan, "
		else
			printf "auto-go-home after scan disabled, "
		if(and(val,16))
			printf "turn on MOTOR power and phase, "
		else
			printf "turn off MOTOR power and phase, "
		if(and(val,8))
			printf "two table motor moving, "
		else
			printf "one table motor moving, "
		if(and(val,4))
			printf "motor reverse, "
		else
			printf "motor forward, "
		printf "bipolar: %s, unipolar: %s",bipolar[and(val,3)],unipolar[and(val,3)]
		return;
	}
if(reg=="03") {
	if(and(val,128))
		printf "alternated CCD TG function enabled, "
	else
		printf "alternated CCD TG function disabled, "
	if(and(val,64))
		printf "select dpi average function, "
	else
		printf "select dpi deletion function, "
	if(and(val,32))
		printf "transparency lamp on, "
	else
		printf "transparency lamp off, "
	if(and(val,16))
		printf "lamp POWER on, "
	else
		printf "lamp POWER off, "
	if(and(val,8))
		printf "lamp sleeping on, "
	else
		printf "lamp sleeping off, "
	printf "lamp on time=%d*64k line period",and(val,7)*(1+FASTMOD)
	return;
}
if(reg=="04") {
	adtype[0]="reserved"
	adtype[1]="16 bits"
	adtype[2]="reserved"
	adtype[3]="reserved"
	filter[0]="color"
	filter[1]="R"
	filter[2]="G"
	filter[3]="B"
	feset[0]="reserved"
	feset[1]="reserved"
	feset[2]="Analog Device"
	feset[3]="Wolfson"
	if(and(val,128))
		printf "B/W lineart, "
	else
		printf "color lineart, "
	if(and(val,64))
		printf "16 bits data, "
	else
		printf "8 bits data, "
	printf "frontend type %s, ",adtype[and(rshift(val,4),3)]
	printf "scan color type %s, ",filter[and(rshift(val,2),3)]
	printf "frontend %s ",filter[and(val,3)]
	return;
}
if(reg=="05") {
	dpihw[0]="600"
	dpihw[1]="1200"
	dpihw[2]="2400"
	dpihw[3]="reserved"
	printf "%s dpi, ",dpihw[and(rshift(val,6),3)]
	gmmtype[0]="12 bits"
	gmmtype[1]="14 bits"
	gmmtype[2]="reserved"
	gmmtype[3]="reserved"
	printf "%s gamma table, ",gmmtype[and(rshift(val,4),3)]
	if(and(val,8))
		printf "enable gamma correction, "
	else
		printf "disable gamma correction, "
	if(and(val,4))
		printf "true gray CIS, "
	else
		printf "normal gray CIS, "
	fmode[0]="9"
	fmode[1]="12"
	fmode[2]="15"
	fmode[3]="reserved"
	nmode[0]="24"
	nmode[1]="12"
	nmode[2]="8"
	nmode[3]="6"
	if(FASTMOD)
		printf "%s clocks/pixel",fmode[and(val,3)]
	else
		printf "%s clocks/pixel",nmode[and(val,3)]
	return;
}
if(reg=="06") {
	if(and(val,16))
		printf "PWRBIT on, "
	else
		printf "PWRBIT off, "
	if(and(val,8))
		printf "shading gain=4, "
	else
		printf "shading gain=8, "
	optest[0]="normal AFE image capture"
	optest[1]="set DRAM bank, power on carriage and ADF test for ASIC simulation"
	optest[2]="pixel count pattern for ASIC image test"
	optest[3]="line count pattern for ASIC image test"
	optest[4]="counter and adder test for ASIC simulation test"
	optest[5]="CCD TG test"
	optest[6]="reserved"
	optest[7]="reserved"
	printf "%s",optest[and(val,7)]
	return;
}
	if(reg=="07") {
		if(and(val,2))
			printf "DMA access under command mode, "
		else
			printf "MPU access under command mode, "
		if(and(val,1))
			printf "DMA read DRAM under command mode, "
		else
			printf "MPU write DRAM under command mode, "
		return;
	}
	if(reg=="08") {
		printf "CCD RS rising edge position=%d",val
		return;
	}
	if(reg=="09") {
		printf "CCD RS falling edge position=%d",val
		return;
	}
	if(reg=="0a") {
		printf "CCD CP rising edge position=%d",val
		return;
	}
	if(reg=="0b") {
		printf "CCD CP falling edge position=%d",val
		return;
	}
	if(reg=="0e") {
		printf "scanner software reset command"
		return;
	}
	if(reg=="0f") {
		printf "motor command=%d",val
		return;
	}
	if(reg=="10") {
		return;
	}
	if(reg=="11") {
		printf "Red exposure time=%d",R[idx-1]*256+R[idx]
		return;
	}
	if(reg=="12") {
		return;
	}
	if(reg=="13") {
		printf "Green exposure time=%d",R[idx-1]*256+R[idx]
		return;
	}
	if(reg=="14") {
		return;
	}
	if(reg=="15") {
		printf "Blue exposure time=%d",R[idx-1]*256+R[idx]
		return;
	}
	if(reg=="16") {
		if(and(val,128))
			printf "CCD CP & RS high when TG high, "
		else
			printf "CCD CP & RS low when TG high, "
		if(and(val,64))
			printf "inverse CCD RGBSEL, "
		else
			printf "forward CCD RGBSEL, "
		if(and(val,32))
			printf "inverse CCD TG, "
		else
			printf "forward CCD TG, "
		if(and(val,16))
			printf "inverse CCD Clock 1, "
		else
			printf "forward CCD Clock 1, "
		if(and(val,8))
			printf "inverse CCD Clock 2, "
		else
			printf "forward CCD Clock 2, "
		if(and(val,4))
			printf "inverse CCD CP & RS, "
		else
			printf "forward CCD CP & RS, "
		if(and(val,2))
			printf "disable CCD TG position Clock 1/2 signal, "
		else
			printf "enable CCD TG position Clock 1/2 signal, "
		if(and(val,1))
			printf "disable CCD TG position CP & RS signal"
		else
			printf "enable CCD TG position CP & RS signal"
		return;
	}
	if(reg=="17") {
		tgmode[0]="without dummy line CCD TG type";
		tgmode[1]="with dummy line CCD TG type";
		tgmode[2]="reserved";
		tgmode[3]="reserved";
		printf "%s, CCD TG width=%d",tgmode[rshift(and(val,192),6)],and(val,63);
		return;
	}
	if(reg=="18") {
		if(and(val,128))
			printf "TG and clock set to Canon CIS style, "
		else
			printf "TG and clock set to non-Canon CIS style, "
		printf "%d time CCD clocks speed for dummy line, ",1+rshift(and(val,96),5)
		if(and(val,16))
			printf "half cycle per pixel for CCD Clock/2, "
		else
			printf "one cycle per pixel for CCD Clock/2, "
		printf "sytem clock for CCD Clock/2 delay=%d, ",rshift(and(val,12),2)
		CKSEL=and(val,3)+1
		printf "%d time CCD Clock speed for capture image",and(val,3)+1
		return;
	}
	if(reg=="19") {
		printf "dummy exposure time=%d",val
		return;
	}
	if(reg=="1a") {
		printf "CCD Clock rising edge position=%d",val
		return;
	}
	if(reg=="1b") {
		printf "CCD Clock falling edge position=%d",val
		return;
	}
	if(reg=="1c") {
		if(and(val,128))
			printf "enable CCD Clock 3, "
		else
			printf "disable CCD Clock 3, "
		if(and(val,64))
			printf "reverse CCD Clock 3, "
		else
			printf "forward CCD Clock 3, "

		printf "Blue channel TG=%d, ",rshift(and(val,48),4)
		printf "Green channel TG=%d, ",rshift(and(val,12),2)
		printf "Red channel TG=%d",and(val,3)
		return;
	}
	if(reg=="1d") {
		if(and(val,128))
			printf "manual CCD Clock/2 programming, "
		else
			printf "automatic CCD Clock/2 programming, "
		printf "CCD shoulder width=%d",and(val,31)
		return ;
	}
	if(reg=="1e") {
		printf "watchdog time=%d, ",rshift(val,4);
		#CIS....
		printf "%d dummy line",and(val,15);
		return ;
	}
	if(reg=="1f") {
		printf "SCANFED=%d",val
		return ;
	}
	if(reg=="20") {
		printf "BUFSEL=%d 2k words",val
		return ;
	}
	if(reg=="21") {
		printf "STEPNO=%d",val
		return ;
	}
	if(reg=="22") {
		printf "FWDSTEP=%d",val
		return ;
	}
	if(reg=="23") {
		printf "BWDSTEP=%d",val
		return ;
	}
	if(reg=="24") {
		printf "FASTNO=%d",val
		return ;
	}
	if(reg=="25") {
		return ;
	}
	if(reg=="26") {
		return ;
	}
	if(reg=="27") {
		printf "LINCNT=%d",and(R[idx-2],3)*65536+R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="28") {
		return ;
	}
	if(reg=="29") {
		printf "LAMPPWM=%d 12 duty",and(R[idx-1],1)*256+R[idx]
		return ;
	}
	if(reg=="2a") {
		return ;
	}
	if(reg=="2b") {
		printf "DRAM data start address=%x ",and(R[idx-1],63)*256+R[idx]
		return ;
	}
	if(reg=="2c") {
		return ;
	}
	if(reg=="2d") {
		printf "DPISET=%d ",and(R[idx-1],7)*256+R[idx]
		return ;
	}
	if(reg=="2e") {
		printf "B&W high threshold=%d",val
		return ;
	}
	if(reg=="2f") {
		printf "B&W low threshold=%d",val
		return ;
	}
	if(reg=="30") {
		return ;
	}
	if(reg=="31") {
		printf "start pixel=%d ",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="32") {
		return ;
	}
	if(reg=="33") {
		printf "end pixel=%d ",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="34") {
		printf "dummy pixel count=%d",val
		return ;
	}
	if(reg=="35") {
		return ;
	}
	if(reg=="36") {
		return ;
	}
	if(reg=="37") {
		printf "maximum word size per line=%d ",R[idx-2]*65536+R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="38") {
		return ;
	}
	if(reg=="39") {
		printf "CCD line period set to %d ",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="3a") {
		return ;
	}
	if(reg=="3b") {
		printf "front end write data=%x ",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="3c") {
		printf "RAM write data=%d",val
		return ;
	}
	if(reg=="3d") {
		return ;
	}
	if(reg=="3e") {
		return ;
	}
	if(reg=="3f") {
		printf "motor feeding steps write=%d ",R[idx-2]*65536+R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="41") {
	if(and(val,128))
		printf("power on, ")
	else
		printf("power off, ")
	if(and(val,64))
		printf("buffer empty, ")
	else
		printf("buffer NOT empty, ")
	if(and(val,32))
		printf("feeding finished, ")
	else
		printf("feeding NOT finished, ")
	if(and(val,16))
		printf("scan finished, ")
	else
		printf("scan NOT finished, ")
	if(and(val,8))
		printf("head at home, ")
	else
		printf("head NOT at home, ")
	if(and(val,4))
		printf("lamp on, ")
	else
		printf("lamp off, ")
	if(and(val,2))
		printf("frontend busy, ")
	else
		printf("frontend ready, ")
	if(and(val,1))
		printf("motor running")
	else
		printf("motor stopped")
	}
	if(reg=="42") {
		return ;
	}
	if(reg=="43") {
		return ;
	}
	if(reg=="44") {
		printf "valid image data words=%d ",R[idx-2]*65536+R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="45") {
		printf "RAM read data=%d",val
		return ;
	}
	if(reg=="46") {
		return ;
	}
	if(reg=="47") {
		printf "front end write data=%x ",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="48") {
		return ;
	}
	if(reg=="49") {
		return ;
	}
	if(reg=="4a") {
		printf "motor feeding steps read=%d ",R[idx-2]*65536+R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="4b") {
		return ;
	}
	if(reg=="4c") {
		return ;
	}
	if(reg=="4d") {
		printf "finished scan lines=%d ",R[idx-2]*65536+R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="4e") {
		return ;
	}
	if(reg=="4f") {
		printf "CCD line period is %d",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="50") {
		printf "frontend read address=%d",val
		return ;
	}
	if(reg=="51") {
		printf "frontend write address=%d",val
		return ;
	}
	if(reg=="52") {
		printf "Red low byte AFE data latch=%d",and(val,31)
		return ;
	}
	if(reg=="53") {
		printf "Red high byte AFE data latch=%d",and(val,31)
		return ;
	}
	if(reg=="54") {
		printf "Green low byte AFE data latch=%d",and(val,31)
		return ;
	}
	if(reg=="55") {
		printf "Green high byte AFE data latch=%d",and(val,31)
		return ;
	}
	if(reg=="56") {
		printf "Blue low byte AFE data latch=%d",and(val,31)
		return ;
	}
	if(reg=="57") {
		printf "Blue high byte AFE data latch=%d",and(val,31)
		return ;
	}
	if(reg=="58") {
		printf "AFE image sampling rising edge=%d, ",and(rshift(val,3),31)
		printf "AFE image sampling pulse width=%d, ",and(val,7)
		return;
	}
	if(reg=="59") {
		printf "AFE dark voltage sampling rising edge=%d, ",and(rshift(val,3),31)
		printf "AFE dark voltage sampling pulse width=%d, ",and(val,7)
		return;
	}
	if(reg=="5a") {
		if(and(val,128))
			printf "Wolfson AFE type, "
		else
			printf "Analog Device AFE type, "
		if(and(val,64))
			printf "select reset level clamp, "
		else
			printf "no reset level clamp, "
		printf "AFE CDSREF=%d, ",and(rshift(val,4),3);
		printf "AFE RLC=%d, ",and(val,15);
	}
	if(reg=="5b") {
		printf "first point of rising edge=%d, ",and(val,31)
		return;
	}
	if(reg=="5c") {
		printf "first point of falling edge=%d, ",and(val,31)
		return;
	}
	if(reg=="5d") {
		printf "second point of rising edge=%d, ",and(val,31)
		return;
	}
	if(reg=="5e") {
		printf "second point of falling edge=%d, ",and(val,31)
		return;
	}
	if(reg=="60") {
		return ;
	}
	if(reg=="61") {
		printf "Z1MOD=%d",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="62") {
		return ;
	}
	if(reg=="63") {
		printf "Z2MOD=%d",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="64") {
		printf "unipolar motor phase=%d",val
		return ;
	}
	if(reg=="65") {
		printf "unipolar motor phase duty cycle=%d/64",and(val,63)
		return ;
	}
	if(reg=="66") {
		return ;
	}
	if(reg=="67") {
		printf "GPO=%04x",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="68") {
		return ;
	}
	if(reg=="69") {
		printf "GPO enable=%04x",R[idx-1]*256+R[idx]
		return ;
	}
	if(reg=="6a") {
		printf "bipolar: %s, unipolar: %s",bipolar[and(rshift(val,6),3)],unipolar[and(rshift(val,6),3)]
		printf "unipolar motor phase duty cycle=%d/64",and(val,63)
		return ;
	}
	if(reg=="6b") {
		printf "fast moving slop steps=%d",val
		return ;
	}
	if(reg=="6c") {
		printf "TGTIME=%d^2 periods, ",and(rshift(val,6),3)
		printf "Z1MOD[18:16]=%d, ",and(rshift(val,3),7)
		printf "Z2MOD[18:16]=%d, ",and(val,7)
		return ;
	}
	if(reg=="6d") {
		printf "go home decelaration steps=%d^2, ",and(rshift(val,5),7)
		printf "stop time (in LPERIOD)=%d, ",and(val,31)
		return ;
	}

	if(reg=="70") {
		return ;
	}
	if(reg=="71") {
		printf "GPI=%04x",R[idx-1]*256+R[idx]
		return ;
	}

	r=strtonum(reg)
	if((r>=strtonum("40")) && (r<=strtonum("4f")))
		printf "writing to a read register %s!",reg;
	if((r>=strtonum("70")) && (r<=strtonum("7f")))
		printf "writing to a read register %s!",reg;
	printf "%s inconnu",reg;
}
/^R..=/ {
	rs=substr($1,2,2);
	vs=substr($1,5,4);
	i=strtonum("0x"rs);
	reg[i]=vs;
	tidx[i]=rs;
}
/sanei_genesys_fe_write_data/ {
	idx=strtonum(substr($0,29,4))
	val=strtonum(substr($0,34,6))
	if(idx>=0 && idx <=3)
		fereg[idx]=val
	if(idx>=40 && idx<=43)
		gain[idx-40]=val
	if(idx>=36 && idx<=38)
		sign[idx-36]=val
	if(idx==35)
		global_sign=val
}
/set_slope_table/ {
	if(substr($1,1,16)=="set_slope_table0")
		table=0
	else
		table=1
	$1=substr($1,18)
	for(i=0;i<NF;i++)
	{
		if(table==0)
			slope0[i]=$(i+1)
		else
			slope1[i]=$(i+1)
	}
	for(i=NF;i<255;i++)
	{
		if(table==0)
			slope0[i]=-1
		else
			slope1[i]=-1
	}
}
/sanei_genesys_start_motor/ {
	printf "==================== SCAN %03d STATUS =================\n",scan
	scan++
	i=0;
	steps=strtonum(reg[33])
	printf "slope_table0="
	while(i<steps)
	{
		printf "%d ",slope0[i]
		i++
	}
	i=0;
	if(and(strtonum(reg[2]),8))
	{
		steps=strtonum(reg[34])
		printf "\nslope_table1="
		while(i<steps)
		{
			printf "%d ",slope1[i]
			i++
		}
	}
	printf "\n"
	for(i=0;i<4;i++)
	{
		if(fereg[i]!=-1)
			printf "fe->reg[%d]=0x%04x\n",i,fereg[i];
	}
	for(i=0;i<4;i++)
	{
		if(sign[i]!=-1)
			printf "fe->sign[%d]=0x%04x\n",i,sign[i];
	}
	for(i=0;i<4;i++)
	{
		if(gain[i]!=-1)
			printf "fe->gain[%d]=0x%04x\n",i,gain[i];
	}
	if(global_sign!=-1)
			printf "fe->global_sign=0x%04x\n",global_sign;
		
	for(i=1;i<111;i++)
	{
		if(reg[i]!="-1")
		{
			printf "R%02x=%s\t",i,reg[i]
			decode(tidx[i],strtonum(reg[i]))
			printf "\n"
		}
	}
	print "==================== SCAN STATUS END ============================="
}
/sanei_genesys_set_buffer_address\(0x1100\)/ {
	printf "gamma="
	getline
	$1=substr($1,37)
	for(i=0;i<(NF-1)/2;i++)
	{
		h=$(2*i+2)
		l=substr($(2*i+1),3)
		v=h""l
		printf "%s ",strtonum(v)
	}
	getline
	$1=substr($1,32)
	for(i=0;i<(NF-1)/2;i++)
	{
		h=$(2*i+2)
		l=substr($(2*i+1),3)
		v=h""l
		printf "%s ",strtonum(v)
	}
	printf "\n"
}
/sanei_genesys_set_buffer_address\(0x0000\)/ {
	printf "shading="
	getline
	$1=substr($1,37)
	for(i=0;i<(NF-1)/2;i++)
	{
		h=$(2*i+2)
		l=substr($(2*i+1),3)
		v=h""l
		printf "%s ",strtonum(v)
	}
	printf "\n"
}
/sanei_genesys_bulk_read_data\(0x45/ {
	print $0
}
/sanei_genesys_bulk_read_data_next/ {
	print $0
}
