#!/bin/bash
#
# data parsing
#
echo "reformatting data ..."
echo "compacting URBs ..."
awk -f filtre.awk $1 >tmp
echo "sorting ..."
sort -n -k 5 <tmp >res
echo "reordering in/out ..."
awk -f swap.awk <res >tmp
echo "depacking ..."
awk -F'*' -f refait.awk <tmp | grep -v skip >res
echo "parsing ..."
awk -f parse1.awk <res >tmp
# filter uneeded button access
grep -v "control  0xc0 0x0c 0x8e 0x20 len     1 read" tmp >res
mv res tmp
#
# apply all scripts for low-level decoding
#
for script in \
motor2.awk \
genesys_get_status.awk \
testR70.awk \
genesys_fe_write_data.awk \
genesys_set_buffer_address.awk \
genesys_set_buffer_address2.awk \
genesys_read_feed_steps.awk \
genesys_bulk_write_data.awk \
genesys_bulk_write_next.awk \
genesys_bulk_read_data.awk \
genesys_bulk_read_next.awk \
genesys_bulk_write_register2.awk \
genesys_bulk_write_register.awk \
bulk_motor.awk \
genesys_read_register.awk \
;
do
	echo "executing "$script"..."
	awk -f $script tmp >res
	mv res tmp
done
mv tmp `basename $1`.decode
